;##########################################################################
;########################## Dodane includy ################################
;##########################################################################
      
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\macros\macros.asm
      
	  include \masm32\include\glu32.inc
      include \masm32\include\opengl32.inc

;##########################################################################
;############################ Biblioteki ##################################
;##########################################################################
	  
	  includelib \masm32\lib\opengl32.lib
	  includelib \masm32\lib\glu32.lib
	  
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib
      includelib \masm32\lib\ole32.lib
      
;##########################################################################
;######################## Lokalne Prototypy ###############################
;##########################################################################

        WinMain          PROTO :DWORD,:DWORD,:DWORD,:DWORD
        WndProc          PROTO :DWORD,:DWORD,:DWORD,:DWORD
        TopXY            PROTO :DWORD,:DWORD
        Paint_Proc       PROTO :DWORD
        RegisterWinClass PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
        MsgLoop          PROTO
        Main             PROTO
        Okno			 PROTO :DWORD
        DialogProc 		 PROTO :DWORD,:DWORD,:DWORD,:DWORD
        
;##########################################################################
;######################## Prototypy OpenGL ################################
;##########################################################################

		CreateGLWindow  PROTO :DWORD, :DWORD, :DWORD, :UINT
		KillGLWindow    PROTO
		ReSizeGLScene   PROTO :DWORD, :DWORD
		InitGL          PROTO
		DrawGLScene     PROTO



;##########################################################################
;############################## MACRO #####################################
;##########################################################################

 		AutoScale MACRO swidth, sheight
        invoke GetPercent,sWid,swidth
        mov Wwd, eax
        invoke GetPercent,sHgt,sheight
        mov Wht, eax

        invoke TopXY,Wwd,sWid
        mov Wtx, eax

        invoke TopXY,Wht,sHgt
        mov Wty, eax
      ENDM
 
 		DisplayMenu MACRO handl, IDnum
        invoke LoadMenu,hInstance,IDnum
        invoke SetMenu,handl,eax
      ENDM
 
 		DisplayWindow MACRO handl, ShowStyle
        invoke ShowWindow,handl, ShowStyle
        invoke UpdateWindow,handl
      ENDM

 		fpc MACRO val:REQ
    LOCAL w,x,y,z,zz,ww

    ;; split type and value, defaulting to REAL4
    z INSTR 1,<&val>,<! >
    IF z EQ 0
        y TEXTEQU <REAL4>
        x TEXTEQU <&val>
    ELSE
        y TEXTEQU @SubStr(<&val>,1,z-1) ;; Type
        x TEXTEQU @SubStr(<&val>,z+1,)  ;; Value
    ENDIF

    ;; replace . with _
    z INSTR 1,x,<!.>
    IF z EQ 0
        w TEXTEQU x
        x CATSTR x,<.0> ;; prevent error message
    ELSE
        w CATSTR @SubStr(%x,1,z-1),<_>,@SubStr(%x,z+1,)
    ENDIF

    ;; replace - with _
    zz INSTR 1,w,<!->
    IF zz EQ 0
        ww TEXTEQU w
    ELSE
        ww CATSTR @SubStr(%w,1,zz-1),<_>,@SubStr(%w,zz+1,)
    ENDIF

    ;; figure out global name for constant
    z SIZESTR y ;; use last char for size distiction
    ww CATSTR <__>,ww,<r>,@SubStr(%y,z,1)

    IF (OPATTR(ww)) EQ 0 ;; not defined
        CONST SEGMENT
            ww y x
        CONST ENDS
    ENDIF
    EXITM ww
ENDM
	
 		Vertex3f	MACRO xx,yy,zz
	push CFLT(zz)
	push CFLT(yy)
	push CFLT(xx)
call glVertex3f
ENDM

 		Color3f macro r,g,b
	invoke glColor3f,CFLT(r),CFLT(g),CFLT(b)
endm

 		literal_float macro	lit_float
			local	local_float

			.data
local_float		real4	lit_float

			.code
			exitm	<local_float>
			endm

 		CFLT macro	lit_float
			exitm	<literal_float(lit_float)>
			endm

 		CFTD macro b:REQ
	LOCAL a
.data
	a qword b
.code
	
	push dword ptr [a+4]
	push dword ptr [a]
endm
CDBL			macro	lit_double
			exitm	<literal_double(lit_double)>
			endm
literal_double		macro	lit_double
			ifidn	@SubStr(<lit_double>, 1, 1), <->
dot_position			equ	@InStr(2, <lit_double>, <.>)
local_double			textequ	@CatStr(<_DBL__>, @SubStr(<lit_double>, 1, dot_position - 1), <_>, @SubStr(<lit_double>, dot_position + 1))
sgn_location			equ	@InStr(1, %local_double, <->)
local_double			textequ	@CatStr(<_>, @SubStr(%local_double, 1, sgn_location - 1), @SubStr(%local_double, sgn_location + 1))
			else
dot_position			equ	@InStr(2, <lit_double>, <.>)
local_double			textequ	@CatStr(<_DBL_>, @SubStr(<lit_double>, 1, dot_position - 1), <_>, @SubStr(<lit_double>, dot_position + 1))
			endif
			%ifndef	local_double
				.data
local_double			real8	lit_double
				.code
           		endif
			exitm	<local_double>
			endm
	

;##########################################################################
;############################## Koniec ####################################
;##########################################################################